require "import"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"
import "java.util.Locale"

-- Define a variable to store the spoken words
local spokenText = ""

-- Define a table for emojis based on Hindi words
local emojiDictionary = {
    -- Common words with emojis
   भाग = "🏃",
गधा = "🐴",
चुप = "🤫",
गंजा = "🧑‍🦲",
पागल = "🤪",
बुद्धू = "🤓",
हंस = "😂",
रो = "😭",
भूत = "👻",
चमगादड़ = "🦇",
कुत्ता = "🐶",
बिल्ली = "🐱",
भालू = "🐻",
सांड = "🐂",
सुअर = "🐷",
बंदर = "🐒",
मछली = "🐟",
तोता = "🦜",
मुर्गा = "🐓",
गाय = "🐄",
बकवास = "🤦",
नाक = "👃",
कान = "👂",
गर्दन = "🦴",
मोटी = "🍔",
पतली = "🍝",
गोलू = "🍩",
चुस्त = "👟",
ढीला = "👖",
नाकाम = "🚫",
हीरो = "🌟",
चमचा = "🥄",
कबूतर = "🕊️",
नौटंकी = "🎭",
फेंकू = "🥏",
मूर्ख = "🤯",
चालाक = "🧐",
सूरज = "🌞",
चांद = "🌙",
अंधेरा = "🌑",
प्लेन = "✈️",
बेवकूफ = "🙃",
धोखेबाज = "🕵️",
भिखारी = "🧔",
आलसी = "😴",
जोकर = "🤡",
पप्पू = "🤭",
गुंडा = "💀",
लोटपोट = "🤣",
जल्लाद = "👹",
नाटकबाज = "🤥",
दमदार = "💪",
गुस्सैल = "😡",
धीमा = "🐌",
तेज = "⚡", 
शरारती = "😜",
चुपचाप = "🤫",
भाग = "🏃",
सुन = "👂",
गंजा = "🧑‍🦲",
पागल = "🤪",
बुद्धिमान = "🧠",
हंसना = "😂",
रोना = "😢",
डरपोक = "😱",
उल्लू = "🦉",
मोटा = "🐷",
हीरो = "🎥",
धोनी = "🏏",
पप्पू = "🤭",
बकवास = "🤦",
चमकदार = "✨",
सूरज = "🌞",
चालाक = "🧐",
अजूबा = "🌍",
मस्ती = "🎉",
साहसी = "🦁",
शांत = "😌",
नौटंकी = "🎭",
जिज्ञासु = "🔍",
रोशनी = "💡", 
 उत्साहित = "🤩",
    थैंक्यू = "🙏",
    सपोर्ट = "🤝",
    प्रेरक = "🌠",
    अद्भुत = "✨",
    हंसना = "😅",
    शांत = "😌",
    याद = "💭",
    भरोसा = "🤞",
    रोशनी = "💡",
    सुधार = "🔧",
    चमक = "🌟",
    रोमांच = "🎢",
    मददगार = "🤗",
    उदासी = "😞",
    उपलब्धि = "🏅",
    दोस्ताना = "😊",
    आरामदायक = "🛏️",
    चालाक = "🧠",
    खोज = "🔎",
    सुकून = "🕊️",
    मस्ती = "🎉",
    ध्यान = "🧘",
    साहस = "🦁",
    जोखिम = "🎯",
    जिज्ञासा = "🧐",
सूरज = "☀️",
    चाँद = "🌙",
    तारा = "⭐",
    बारिश = "🌧️",
    इंद्रधनुष = "🌈",
    खाना = "🍽️",
    चाय = "🍵",
    केक = "🍰",
    चॉकलेट = "🍫",
    बर्गर = "🍔",
    पिज्जा = "🍕",
    दिल = "❤️",
    टूटा_दिल = "💔",
    प्यार = "💕",
    हग = "🤗",
    चुम्बन = "😘",
    मुस्कान = "😊",
    गुस्सा = "😡",
    उदास = "😢",
    शर्माना = "☺️",
    सोच = "🤔",
    खुशी = "😁",
    बर्थडे = "🎂",
    गिफ्ट = "🎁",
    पार्टी = "🎉",
    मोमबत्ती = "🕯️",
    नाचना = "💃",
    गाना = "🎤",
    संगीत = "🎶",
    हाँ = "✔️",
    ना = "❌",
    इंतजार = "⌛",
    चलो = "🏃",
    सोना = "😴",
    जागना = "🌅",
    फोन = "📱",
    लैपटॉप = "💻",
    टीवी = "📺",
    किताब = "📖",
    प्रपोज = "💍",
    रिंग = "💎",
    फूल = "🌹",
    साथ = "👫",
    हाथ_पकड़ना = "✋",
    वादा = "🤝",
    हेलो = "👋",
    अलविदा = "👋",
    माइक = "🎙️",
    कैमरा = "📸",
    प्लेन = "✈️",
    कार = "🚗",
    ट्रेन = "🚆",
    पासपोर्ट = "🛂",
    यात्रा = "🧳",
    झंडा = "🏳️‍🌈",
    भारत = "🇮🇳",
    दुनियां = "🌍",
    पेंटिंग = "🎨",
 आलू = "🥔",
    टमाटर = "🍅",
    चावल = "🍚",
    दूध = "🥛",
    पानी = "💧",
    हवा = "💨",
    आग = "🔥",
    बर्फ = "❄️",
    हाथी = "🐘",
    घोड़ा = "🐴",
    कुत्ता = "🐕",
    बिल्ली = "🐱",
    शेर = "🦁",
    टाइगर = "🐅",
    सांप = "🐍",
    पक्षी = "🐦",
    मच्छर = "🦟",
    तितली = "🦋",
    मछली = "🐟",
    हाथ = "✋",
    पैर = "🦵",
    आंख = "👁️",
    नाक = "👃",
    मुंह = "👄",
    हंसी = "😂",
    रोना = "😭",
    सपना = "💭",
    सपनों_का_राजा = "👑",
    ठीक = "👌",
    सही = "✅",
    गलत = "❌",
    जल्दी = "⏩",
    धीमे = "⏳",
    रुको = "✋",
    चलते_हैं = "🚶‍♂️",
    आओ = "👋",
    ओके = "👌",
    वाह = "👏",
    बढ़िया = "👍",
    क्यूट = "🥰",
    मस्त = "😎",
 खुश = "😊",
    दुखी = "😢",
    प्यार = "❤️",
    गुस्सा = "😡",
    कूल = "😎",
    अच्छा = "👍",
    बुरा = "👎",
    हंसी = "😂",
    धन्यवाद = "🙏",
    खुशी = "😄",
    मुस्कान = "😊",
    नमस्ते = "🙏",
    नमस्कार = "👋",
    क्या_हाल_है = "😃",
    कैसे_हो = "😄",
    शाबाश = "👏",
    ध्यान = "🧘‍♂️",
    चिंता = "😟",
    चलो = "🏃‍♂️",
    चाय = "☕",
    पानी = "💧",
    खाना = "🍽️",
    सोना = "💤",
    काम = "💼",
    स्कूल = "🏫",
    दोस्त = "👫",
    परिवार = "👨‍👩‍👧‍👦",
    सस्ता = "💸",
    महंगा = "💰",
    यात्रा = "✈️",
    छुट्टी = "🏖️",
    हास्य = "😂",
    प्यार_भरा = "💖",
    शांति = "🕊️",
    मित्रता = "🤝",
    लक्ष्य = "🎯",
    सेहत = "💪",
    खुशी_का_समय = "🎉",
    उत्सव = "🎊",
    कामयाबी = "🏆",
    सीखना = "📚",
    भाई = "👬",
    बहन = "👭",
    परिवार_का_साथ = "👨‍👩‍👧‍👦",
    मदद = "🆘",
    खुश_रहना = "😁",
    परिश्रम = "💪",
    जीवन = "🌱",
    शिक्षा = "🎓",
    स्वतंत्रता = "🕊️",
    उम्मीद = "🌟",
    दोस्ती = "👯‍♂️",
    प्यार_में_हंसी = "🤣",
    शरारत = "😜",
    मोहब्बत = "💘",
    उत्साह = "⚡",
    जोश = "🔥",
    ताजगी = "🌸",
    सच्चाई = "📜",
    शक्ति = "🦸‍♂️",
    उत्साही = "💥",
    शुभकामनाएं = "🎉",
    संघर्ष = "⚔️",
    विजय = "🏅",
    प्यार_का_इज़हार = "💌",
    आशा = "🌞",
    आभार = "🤗",
    मुस्कुराहट = "😁",
    बाय = "👋",
    आराम = "🛋️",
    आकाश = "🌌",
    अच्छा_दिन = "🌅",
    सही = "✅",
    गलत = "❌",
    भविष्य = "🔮",
    सुख_शांति = "🌼",
    धन्यवाद_दोस्त = "👯",
    बधाई_हो = "🎉",
    नया_साल = "🎆",
    स्वास्थ = "💖",
    भारत = "🇮🇳",
    अमेरिका = "🇺🇸",
    इंग्लैंड = "🇬🇧",
    चीन = "🇨🇳",
    जापान = "🇯🇵",
    फ्रांस = "🇫🇷",
    रूस = "🇷🇺",
    ऑस्ट्रेलिया = "🇦🇺",
    कनाडा = "🇨🇦",
    ब्राजील = "🇧🇷",
    दक्षिण_कोरिया = "🇰🇷",
    दक्षिण_अफ्रीका = "🇿🇦",
    दिल_टूटना = "💔",
    धोखा = "💔",
    मेरी_जान = "💖",
    मेरे_सोना = "💎",
    मेरे_बाबू = "👶",
    गर्लफ्रेंड = "👩‍❤️‍👨",
    प्यारी = "💖",
    तुम्हारा_हुआ = "💍",
    मेरी_लाइफ = "🌟",
    मैं_तुमसे_प्यार_करता_हूँ = "❤️",
    तुम_मेरी_जिंदगी_हो = "💑",
    तुम_से_बहुत_प्यार_है = "❤️",
    पढ़ाई = "📖",
    लिखाई = "✍️",
    गाना = "🎵",
    सुनना = "🎧",
    नाचना = "💃",
    खेलना = "🏀",
    देखना = "👀",
    बोलना = "🗣️",
    सफर = "🚗",
    बारिश = "🌧️",
    धूप = "☀️",
    -- नए इमोजी
    आश्चर्य = "😲",
    मज़ा = "🥳",
    तरक्की = "🚀",
    आलस = "😴",
    मेहनत = "🛠️",
    प्रेरणा = "🌟",
    बदलाव = "🔄",
    आराम = "🛌",
    हिम्मत = "🦁",
    डर = "😨",
    यात्रा = "🌍",
    प्रकृति = "🌿",
    ऊर्जा = "⚡",
    सपने = "💭",
    कला = "🎨",
    संगीत = "🎼",
    प्रेमिका = "👩‍❤️‍💋‍👨",
    प्रेमी = "👨‍❤️‍💋‍👨",
    किताबें = "📚",
    परीक्षा = "📝",
    सफलता = "🏆",
    व्यापार = "💼",
    तकनीक = "💻",
    इंटरनेट = "🌐",
    मोबाइल = "📱",
    संदेश = "✉️",
    सवाल = "❓",
    जवाब = "✅",
    मौसम = "⛅",
    बचपन = "🧒",
    शादी = "💍",
    सच्चाई = "🔎",
    विज्ञान = "🔬",
    फिल्म = "🎬",
    गाड़ी = "🚗",
    सूरज = "☀️",
    चांद = "🌕",
    तारे = "⭐",
    इंद्रधनुष = "🌈",
    समुद्र = "🌊",
    फूल = "🌸",
    आग = "🔥",
}

-- Function to store recognized words
function saveWords(words)
    spokenText = words
end

-- Function to insert emoji after every word based on the emoji dictionary
function addEmojiAfterWords(text)
    local words = {}
    for word in text:gmatch("%S+") do
        table.insert(words, word)
    end
    
    local result = ""
    for _, word in ipairs(words) do
        result = result .. word .. " "
        if emojiDictionary[word] then
            result = result .. emojiDictionary[word] .. " "
        end
    end
    return result
end

-- Function to start listening for speech input
function startListening()
    local verbalizationDetected = false
    local node = service.getEditText()
    if node == nil then
        print("No text box is present.")
        return false
    end

    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "hi-IN")
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
    local speechListener = RecognitionListener{
        onResults = function(results)
            local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                verbalizationDetected = true
                local recognizedText = data.get(0)
                saveWords(recognizedText)
                local editText = service.getText(node)
                local textWithEmojis = addEmojiAfterWords(recognizedText)
                service.insertText(node, textWithEmojis)
            end
            if not verbalizationDetected then
                kill()
                return false
            end
        end,
        onError = function()
            kill()
            return false
        end
    }

    speechRecognizer.setRecognitionListener(speechListener)
    speechRecognizer.startListening(recognizerIntent)
end

startListening()
return true